<template>
  <basic-container>
    <avue-crud :option="option"
               v-model:search="search"
               v-model:page="page"
               v-model="form"
               :table-loading="loading"
               :data="data"
               :permission="permissionList"
               :before-open="beforeOpen"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template #menu-left>
        <!-- <el-button type="danger"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.productBatch_delete"
                   @click="handleDelete">删 除
        </el-button> -->
        <!-- <el-button type="warning"
                   plain
                   icon="el-icon-download"
                   @click="handleExport">导 出
        </el-button> -->
      </template>
      <template #details-form>
        <avue-crud :option="optionSub" ref="detailCrud"
                  :data="form.details">
                  <!-- <template slot-scope="{row,index}" slot="menu">
                    <el-button v-if="row.$cellEdit"
                              text
                              icon="el-icon-cancel"
                              type="primary"
                              @click="rowDelSub(index)">删除</el-button>
                  </template>
                  <template slot-scope="{row}" slot="tradeTotalPriceForm">
                    <span>{{(row.tradeUnitPrice * row.tradeNum)? (row.tradeUnitPrice * row.tradeNum).toFixed(2):0 }}</span>
                  </template> -->

                  <!-- <template slot-scope="{row,index}" slot="productIdForm">
                    <el-button v-if="row.$cellEdit"
                              text
                              icon="el-icon-cancel"
                              type="primary"
                              @click="rowDelSub(index)">删除</el-button>
                  </template> -->
        </avue-crud>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/productBatch/productBatch";
  import option from "@/option/productBatch/productBatch";
  import optionSub from "@/option/productBatch/product.js";
  import {mapGetters} from "vuex";
  import {exportBlob} from "@/api/common";
  import {getToken} from '@/utils/auth';
  import {downloadXls} from "@/utils/util";
  import {dateNow} from "@/utils/date";
  import NProgress from 'nprogress';
  import 'nprogress/nprogress.css';

  export default {
    data() {
      return {
        form: {},
        query: {},
        search: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: option,
        data: [],
        optionSub: optionSub
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.validData(this.permission.productBatch_add, false),
          viewBtn: this.validData(this.permission.productBatch_view, false),
          delBtn: this.validData(this.permission.productBatch_delete, false),
          editBtn: this.validData(this.permission.productBatch_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        this.$refs.detailCrud.$refs.cellForm.validate((valid) => {
          if (valid) {
            add(row).then(() => {
              this.onLoad(this.page);
              this.$message({
                type: "success",
                message: "操作成功!"
              });
              done();
            }, error => {
              loading();
              window.console.log(error);
           });
          } else {
            loading();
            return false;
          }
        })
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      handleExport() {
        let downloadUrl = `/pl-productBatch/productBatch/export-productBatch?${this.website.tokenHeader}=${getToken()}`;
        const {
            batchNo,
            productName,
            productModel,
        } = this.query;
        let values = {
            batchNo_: batchNo,
            productName_: productName,
            productModel_: productModel,
        };
        this.$confirm("是否导出数据?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          NProgress.start();
          exportBlob(downloadUrl, values).then(res => {
            downloadXls(res.data, `产品入库批次表${dateNow()}.xlsx`);
            NProgress.done();
          })
        });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        if (["add"].includes(type)) {
          if(!this.form.details){
            this.form.details = [{"$cellEdit":true},{"$cellEdit":true},{"$cellEdit":true},{"$cellEdit":true},{"$cellEdit":true},{"$cellEdit":true},{"$cellEdit":true}]
          }
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;

        const {
          batchNo,
          productName,
          clientId,
          factoryId,
          productModelId
        } = this.query;

        let values = {
          batchNo_like: batchNo,
          productName_like: productName,
          productModelId: productModelId,
          clientId: clientId,
          factoryId: factoryId,
        };

        getList(page.currentPage, page.pageSize, values).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
          this.$nextTick(() => {
            //放在数据加载完后执行
            this.$refs.crud.dicInit('cascader');
          })
        });
      }
    }
  };
</script>

<style>
</style>
